// phonicstwister.scad 
// Author: Brendon
//
// Bilibili: https://space.bilibili.com/2017921194
// Youtube: https://www.youtube.com/channel/UCwlO6oSrHtHFOW_LHA4V6MA
// Thingiverse: https://www.thingiverse.com/cantareus 
//
// Licence : Creative Commons - Attribution Sharealike

use <shortcuts.scad>
include <P:/Zortrax 3D Printer/1. SVRC Designs/Braille script.scad>
//Download from https://www.dafont.com/kg-primary-penmanship.font
//It's free for personal use.

//For rings to connect together they should have the same number
// of sides, thickness and height. The width can vary between rings.

Preset = "Magic E"; //["CVC", "Numbers", "Magic E", "R & L blends", "Custom"]

Font = "Rockwell Bold:style=Regular";//[KG Primary Penmanship,Comic Sans MS, Rockwell Bold]
Font_Scale = 0.3; //[0.5:0.1:1.2]
output = "Print Layout"; //[Print Layout, Assembled, Single]
type = "Ring"; //[Ring, Text]

//Only used when generating a single ring.
ring_number = 0; //[0:10]

//Last ring has no tab.
terminate = "Yes"; //[Yes, No]
Width = 12;
Height = 14;
Thickness = 2.4;
Tab = Thickness * 2;
Clearance = 0.2;
sides = 4;
side_radius=7;
//braille
//d
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,0,0,1,1,0);
//g
rotate([0,0,360/sides])
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,1,0,1,1,0);
//m
rotate([0,0,360/sides*2])
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,0,1,1,0,0);
//r
rotate([0,0,360/sides*3])
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,1,1,0,1,0);

translate([0,23.85,0]){
//a
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,0,0,0,0,0);
//i
rotate([0,0,360/sides])
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(0,1,0,1,0,0);
//o
rotate([0,0,360/sides*2])
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,0,1,0,1,0);
//u
rotate([0,0,360/sides*3])
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,0,1,0,0,1);
}

translate([23.85,0,0]){
//m
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,0,1,1,0,0);
//n
rotate([0,0,360/sides])
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,0,1,1,1,0);
//p
rotate([0,0,360/sides*2])
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,1,1,1,0,0);
//t
rotate([0,0,360/sides*3])
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(0,1,1,1,1,0);
}


translate([23.85,23.85,0]){
//e
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,0,0,0,1,0);
//blank
//rotate([0,0,360/sides])
//translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,0,1,1,1,0);
//e
rotate([0,0,360/sides*2])
translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(1,0,0,0,1,0);
//blank
//rotate([0,0,360/sides*3])
//translate([side_radius,-Width*0.01,Height/3]) rotate([-90,-90,180]) braille(0,1,1,1,1,0);
}
//Edit in scad file, can't edit in customizer.
custom = [["", "", "", ""],
["", "", "", ""],
["", "", "", ""],
["", "", "", ""]];

module customizer_end(){}

CVC = [["v", "f", "h", "j", "r", "s", "w", "y", "z"],
       ["a", "e", "i", "o", "u", "a", "e", "i", "o"],
       ["b", "d", "g", "m", "n", "p", "s", "t", " "]];

RL_Blends = [["c", "b", "d", "f", "g", "p"],
             ["r", "l", "r", "l", "r", "l"],
             ["a", "e", "i", "o", "u", " "],
             ["b", "g", "m", "n", "p", "t"]];

letters = [["b", "c", "d", "f", "g", "p", "q", "s", "t", "w"], 
           ["a", "e", "i", "o", "u", "h", "l", "r", "m", "n"],
           ["a", "e", "i", "o", "u", "f", "l", "s", "t", "z"],
           ["e", "h", "l", "m", "n", "f", "l", "s", "t", "z"]];

numbers = [["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"],
           ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"],
           ["+", " ", "-", " ", " ", "/", " ", "*", " ", " "],
           ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"],
           ["=", " ", " ", " ", " ", "=", " ", " ", " ", " "],
           ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"],
           ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]];

magic_e = [["d", "g", "m", "r"],
           ["a", "i", "o", "u"],
           ["m", "n", "p", "t"],
           ["e", " ", "e", " "]];


combination = Preset == "CVC"?CVC:
              Preset == "Numbers"?numbers:
              Preset == "Letters"?letters:
              Preset == "Magic E"?magic_e:
              Preset == "R & L blends"?RL_Blends:
              Preset == "Custom"?custom:[[" "]];

font = 
       Font == "Rockwell Bold"?"Rockwell:style=Bold":
       Font;

Sides = max(max([for(i = combination)len(i)]), 3);
Num_Rings = len(combination);

Outer_Diameter = Height / tan(180/Sides);
Apothem = Height / tan(180/Sides) / 2;
Circumradius = Height / sin(180/Sides) / 2;
Inner_Diameter = Outer_Diameter - Thickness * 2;


$fa = 5;
$fs = 0.4;

if(output == "Single")
{
  if(type == "Text")
    ring_text(combination[ring_number]);
  else if(type == "Ring")
    ring(combination[ring_number], last = (terminate=="Yes"));
}
else if(output == "Print Layout")
  for(i = [0:Num_Rings-1])
  {
    Tx(floor(i/floor(sqrt(Num_Rings))) * (Circumradius * 2 + 4))
      Ty((i % floor(sqrt(Num_Rings))) *  (Circumradius * 2 + 4))
      if(type == "Ring")
        ring(combination[i], last = terminate == "Yes" && i + 1 == Num_Rings);
      else if(type == "Text")
        ring_text(combination[i]);
  }
else if(output == "Assembled")
{
  for(i = [0:Num_Rings-1])
  {
    Tz(i * (Width + Clearance))
    {
      ring(combination[i], last = (terminate == "Yes" && (i + 1 == Num_Rings)));
      color("black")
        ring_text(combination[i]);
    }
  }
}

module ring_blank(last = false)
{
 D()
  { 
    U()
    {
      //Outer polygon
      Rz(180 / Sides)
        Cy(d = Height / sin(180/Sides), $fn = Sides, h = Width, C = false);

      //Connection tabs
      if(!last)
        Tz(Width - Thickness)
          Cy(d = Inner_Diameter - Clearance*2, h = Tab + Thickness, C = false);
    }

    Tz(Width - Thickness)
      Tz(-0.01)
      {
        Cy(d1 = Inner_Diameter, d2 = Inner_Diameter - Thickness * 2, h = Thickness, C = false);
        Cy(d = Inner_Diameter - Thickness * 2, h = Width, C = false);
      }

    D()
    {
      r = 1;
      
      Cy(d = Inner_Diameter, h = (Width - (last?-1:Thickness)) * 2);

      Tz(Tab - 1.2 - Clearance)
      {
        //Notches for positioning
        rotN(N = Sides, r = 0)
          Tx(Inner_Diameter/2 + r*cos(180/8) - Clearance*0.5)
            Rz(22.5)
              Cy(r = r + Clearance * 1.5, h = 2, C = false, $fn = 8);

        //Ring to lock in tabs.
        rotate_extrude(angle = 360)
        {
          Tx(Inner_Diameter/2 + r*cos(180/8) - Clearance * 2)
            Rz(22.5)
              Ci(r = r, $fn = 8);
        }
      }
    }
    
    rotN(N = Sides, r = 0)
    {
      Tz(Width + 0.2)
      {
        //Cut connection ring into tabs
        Ty(-0.2)
          Cu([Inner_Diameter,0.4,Width], C = false);

        //Notch in top for clicker.
        Tz(Tab)
          Tx(Inner_Diameter/2)
            Cy(r =  1, h = 2, $fn = 4);
      }
    }
    Tz(Width + Tab - 1.2)
      rotate_extrude(angle = 360)
      {
        r = 1;

        Tx(Inner_Diameter/2 + r*cos(180/8) - Clearance * 3)
          Rz(22.5)
            Ci(r = r, $fn = 8);
      }
  }
}

module ring_text(letters)
{
  for(i = [0:Sides-1])
    Rz(i * 360 / Sides)
      Tz(Width/2)
        Tx(Apothem)
          Ry(90)
            Rz(180)
              Tz(-0.3)
                Ty(-Width/3)
                linear_extrude(1, convexity = 10, center = true)
                  text(letters[i],size = Height * Font_Scale, halign = "center", valign = "center", font = font);
}

module ring(letters, last = false)
{
  D()
  { 
    ring_blank(last);
    ring_text(letters);
  } 
}
